import os
import re
import urllib
import requests

class ImageCrawller:
    def __init__(self, save_dirpath, start_page, maximum_download):
        self.save_dirpath = save_dirpath
        self.crawl_url_list = [start_page]
        self.stocked_url = set()
        self.maximum_download = maximum_download
        self.download_counter = 0

    def run(self):
        while True:
            # 処理1: 探索するURLがなければ終了。規定数以上を集めていても終了
            if len(self.crawl_url_list) == 0:
                break
            if self.download_counter >= self.maximum_download:
                break

            # 処理2: 次に調べるHTMLのURLを取得
            crawl_url = self.crawl_url_list.pop(0)

            # 処理3: HTMLページから絶対URLを抽出する
            urls = self.get_abs_urls(crawl_url)

            # 処理4: 絶対URLをHTMLかイメージかに分類する。イメージのリストを返す
            image_url_list = self.get_image_url_list(urls)

            # 処理5: リストに格納されたイメージを全て保存する
            self.save_images(image_url_list)

        print('Finished')

